#include <stdlib.h>
#include <stdio.h>
#include <string.h>

static void processdeliplayer(char *filename);
static unsigned int readbig(char *ptr);
static void processstring(char *str);

static void processstring(char *str) {
  int i=0;
  while(str[i]) {
    if(str[i]=='\n') str[i]=' ';
    i++;
  }
}

static unsigned int readbig(char *ptr) {
  unsigned char *p = (unsigned char *) ptr;
  unsigned int x = p[3]+(p[2]<<8)+(p[1]<<16)+(p[0]<<24);
  // fprintf(stderr,"redbig: x = 0x%.8x\n",x);
  return x;
}

int main(int argc, char **argv) {
  int i;
  for(i=1;i<argc;i++) {
    processdeliplayer(argv[i]);
  }
  return 0;
}

static void processdeliplayer(char *filename) {
  char buf[1025];
  int i;
  unsigned int x,y;
  FILE *File;
  unsigned int *tab;
  char *beg;
  File = fopen(filename,"r");
  if(File==0) return;
  i = fread(buf,1,1024,File);
  fclose(File); File = 0;
  buf[1024]=0;
  if(*((unsigned int*)buf)==0xf3030000) {
    for(i=0;i<900;i++) {
      if(*((unsigned int *)(buf+i)) == 0x754eff70) {
	if(strncmp(buf+i+4,"DELIRIUM",8)==0) {
	  fprintf(stdout,"FILENAME: %s\n",filename);
	  beg = buf+i;
	  tab = (unsigned int *) (beg+readbig(beg+12));
	  if(beg[16]=='$' && beg[17]=='V')
	    fprintf(stdout,"VERSION: %s\n",beg+16);
	  for(i=0;;i+=2) {
	    x = readbig((char*) (tab+i));
	    y = readbig((char*) (tab+i+1));
	    if(x==0) break;
	    if(x==0x80004459) {
	      fprintf(stdout,"PLAYERNAME: %s\n",beg+y);
	    } else if(x==0x8000445a) {
	      processstring(beg+y);
	      fprintf(stdout,"CREDITS: %s\n",beg+y);
	    } else if(x==0x80004474) {
	      if((y & 0x2)!=0) {
		fprintf(stdout,"HAS SONGEND SUPPORT\n");
	      }
	    }
	  }
	  fprintf(stdout,"\n");
	  return;
	}
      }
    }
  }
  fprintf(stderr,"%s is not a deliplayer\n",filename);
}

